<?php

namespace Console\Commands;

use Openguru\OpenCartFramework\QueryBuilder\Connections\ConnectionInterface;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Console\Style\SymfonyStyle;

class CustomerCountsCommand extends TeleCartCommand
{
    protected static $defaultName = 'customer:counts';
    protected static $defaultDescription = 'Обновление счетчиков заказов для всех клиентов';

    private ConnectionInterface $database;

    public function __construct(ConnectionInterface $database)
    {
        parent::__construct();
        $this->database = $database;
    }

    protected function execute(InputInterface $input, OutputInterface $output): int
    {
        $io = new SymfonyStyle($input, $output);
        
        $io->title('Обновление счетчиков заказов клиентов');
        $io->writeln('Выполняется пересчёт счетчиков заказов...');

        $sql = <<<SQL
            update telecart_customers
            set orders_count = (select count(*) from oc_order where oc_order.customer_id = telecart_customers.oc_customer_id)
            where true;
SQL;

        $this->database->statement($sql);

        $io->success('Счетчики заказов успешно обновлены!');

        return Command::SUCCESS;
    }
}
